#!/usr/bin/env node
const lib = require("./lib");

if (process.argv.length <= 3) {
    console.log("Insufficient parameter!");
    process.exit(1);
}

const command = process.argv[2];
const numbers = [];

function isNumber(n) {
    if (isNaN(n)) {
        console.log("Some arguments are not numbers!");
        process.exit(1);
    }
}

process.argv.slice(3, process.argv.length).forEach((n) => {
    const index = n.indexOf("@");
    if (index === -1) {
        isNumber(n);
        numbers.push(parseFloat(n));
    } else {
        isNumber(n.slice(0, index));
        const frontNumber = parseFloat(n.slice(0, index));
        const lastNumber = parseFloat(n.slice(index + 1));
        if (
            lastNumber <= 0 ||
            !Number.isInteger(lastNumber) ||
            isNaN(n.slice(index + 1))
        ) {
            console.log("Invalid repeat!");
            process.exit(1);
        }

        for (let i = 0; i < lastNumber; i++) {
            numbers.push(frontNumber);
        }
    }
});

let result;
switch (command) {
    case "sum":
        result = lib.sum(numbers);
        break;
    case "avg":
        result = lib.avg(numbers);
        break;
    case "max":
        result = lib.max(numbers);
        break;
    case "min":
        result = lib.min(numbers);
        break;
    case "med":
        result = lib.med(numbers);
        break;
    default:
        console.log("Wrong command!");
        process.exit(1);
}

console.log(result);
